SystemOrganization addCategory: #'Glamour-Magritte-Presentations'!

GLMMorphicWidgetRenderer subclass: #GLMMorphicMagritteRenderer
	instanceVariableNames: 'scrollPane containerMorphClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Magritte-Presentations'!

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/30/2011 15:54'!
actOnPresentationUpdated: ann
	scrollPane scrollTarget: (self magritteMorphFrom: ann presentation) ! !

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'TudorGirba 9/16/2011 10:54'!
magritteMorphFrom: aMagrittePresentation
	| toShow description magritteMorph magritteDescriptionMorph |
	toShow := aMagrittePresentation displayValue.
	description := (aMagrittePresentation magritteDescription glamourValue: toShow) copy.
	"Using MAContainerMorph can raise some problems, as it try to delete morphs after commiting. We don't want this behavior."
	(description morphClass = MAContainerMorph)
		ifTrue: [description morphClass: MASilentContainerMorph]. 
	magritteDescriptionMorph :=  (description asMorphOn: toShow)
		onAnswer: [ :value | aMagrittePresentation reactOnAnswerFor: value ].
	magritteMorph := magritteDescriptionMorph
		addButtons;
		morph.
	magritteMorph
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		layoutChanged.
	^ magritteMorph! !

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'AlexandreBergel 9/22/2015 12:31'!
render: aMagrittePresentation		.
	scrollPane := GeneralScrollPane new.
	scrollPane changeScrollerTableLayout.
	scrollPane scrollTarget: (self magritteMorphFrom: aMagrittePresentation).
	scrollPane layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ 25 corner: 0 @ 0)).

	aMagrittePresentation when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ scrollPane! !

!GLMBasicExamples methodsFor: '*Glamour-Magritte-Presentations' stamp: 'AndreiChis 10/25/2015 16:00'!
magritte
	<glmBrowser: 'Magritte presentation' input: 'GLMMagrittePersonExample sampleData'>
	"self new magritte openOn: GLMMagrittePersonExample sampleData"
	"GLMMagrittePersonExample sampleReset"  
	"note, sampleData is aGLMAnnouncingCollection"
	
	| browser |
			
	browser := GLMTabulator new initialExtent: 600@300.
	browser column: #list; column: #detail.
	browser transmit to: #list ; andShow: [ :a | 
		a list
			title: 'Contacts';
			format: [ :person | person name ] ;
			updateOn: GLMItemAdded from: [ GLMMagrittePersonExample sampleData ] ;
			updateOn: GLMItemRemoved from: [ GLMMagrittePersonExample sampleData ] ;
			act: [ :listPresentation :glmAC | 
					| newItem | 
					newItem := GLMMagrittePersonExample new name: 'New...'  .
					glmAC add: newItem beforeOrLast: listPresentation selection.
					listPresentation selection: newItem.
				]	icon: GLMUIThemeExtraIcons glamorousAdd 
					entitled: 'Add' ;
			act: [ :listPresentation :glmAC | 
					glmAC remove: listPresentation selection ifAbsent: []
				]	icon: GLMUIThemeExtraIcons glamorousRemove 
					entitled: 'Remove' .
	].

	browser transmit from: #list ; to: #detail ; andShow: [ :a | 
		a magritte
			title: 'Details';
			description: [:person | person magritteDescription] ;
			onAnswer: [ :person :presentation | browser update ] . 
	].

	^ browser! !

!GLMCompositePresentation methodsFor: '*Glamour-Magritte-Presentations' stamp: 'TudorGirba 1/2/2012 01:15'!
magritte
	^ self custom: GLMMagrittePresentation new! !

!GLMMorphicRenderer methodsFor: '*Glamour-Magritte-Presentations' stamp: 'TudorGirba 1/13/2011 13:46'!
renderMagrittePresentation: aMagrittePresentation 
	^ GLMMorphicMagritteRenderer render: aMagrittePresentation from: self! !

GLMPresentation subclass: #GLMMagrittePresentation
	instanceVariableNames: 'magritteDescription answerBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Magritte-Presentations'!

!GLMMagrittePresentation methodsFor: 'accessing' stamp: 'tg 5/15/2009 13:53'!
description: anObject
	"convenience method for scripting"
	
	magritteDescription := anObject! !

!GLMMagrittePresentation methodsFor: 'accessing' stamp: 'TudorGirba 11/24/2012 22:27'!
magritteDescription
	"By default the we read it via the #description selector"
	^ magritteDescription ifNil: [ magritteDescription := #magritteDescription ]! !

!GLMMagrittePresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/16/2011 10:41'!
onAnswer: aBlock
	answerBlock := aBlock! !

!GLMMagrittePresentation methodsFor: 'accessing' stamp: 'BenComan 3/10/2012 01:55'!
reactOnAnswerFor: aValue
	self update.
	^ answerBlock glamourValue:
		(aValue asGlamorousMultiValue, 
		self asGlamorousMultiValue, 
		self entity asGlamorousMultiValue)! !

!GLMMagrittePresentation methodsFor: 'rendering' stamp: 'tg 5/6/2009 13:17'!
renderGlamorouslyOn: aRenderer 
	^ aRenderer renderMagrittePresentation: self! !
